angular.module('app.controllers', [])

/*==========================================================================
 ====================== App Search ====================================
 =========================================================================*/
 .controller('searchCtrl', function($scope,SongBDFactory) {
	$scope.val='';
	window.ga.trackView('searchScreen');
	$scope.srchchange = function () {
		$scope.names ={};
		var value=$scope.val;
		if(value.length >3){
			SongBDFactory.searchSongs(value)
			.then (function  (results) {
				if(results.rows.length>0){
					
					for (var i = 0; i < results.rows.length; i++) {
						$scope.names[i] = results.rows.item(i);
					}
				}
					else if(results.rows.length==0){
					$scope.names.length=0;
					
				}
				else
					$scope.ressetserach();
			}, function  (error) {
				console.log(error.message);
			}
			);

    }

}

$scope.ressetserach = function () {
	$scope.val = "";
	$scope.names ={};
	console.log('ef');
}

})
/*==========================================================================
 ====================== App Alpha ====================================
 =========================================================================*/

 .controller('alphaCtrl', function($scope,SongBDFactory,$ionicLoading,$timeout) {
 	window.ga.trackView('alphaScreen');

 	var letters=['A','B','C','D','E','F','G','H','I','J','L','M','N','O','P','Q','R','S','T','U','V'];
 	
 	$scope.groups = [];

 	function accordionData (letters) {
 		for (var i=0; i<letters.length; i++) {
 			$scope.groups[i] = {
 				name: letters[i],
 				items: []
 			};
 		}
 		$ionicLoading.hide();
 	}

 	$scope.getSongsFromLetter = function(letter,id){
 		var songs={};
 		SongBDFactory.getSongsFromLetter(letter)
 		.then (function  (results) {
 			for (var i = 0; i < results.rows.length; i++) {
 				songs[i] =	results.rows.item(i);
 			}
 			$scope.groups[id].items = songs;
 		}, function  (error) {
 			console.log(error.message);
 		}
 		);
 	}


 	$ionicLoading.show({
 		template: "loading..."
 	});

 	accordionData(letters);
 	

 	$scope.toggleGroup = function(group,id) {
 		
 		
 		if ($scope.isGroupShown(group)) {
 			$scope.groups[id].items={};
 			$scope.shownGroup = null;
 		} else {
 			$scope.getSongsFromLetter(group.name,id);
 			$scope.shownGroup = group;
 		}
 	}; 

 	$scope.isGroupShown = function(group) {
 		return $scope.shownGroup === group;
 	};

 })

/*==========================================================================
 ====================== App Alpha ====================================
 =========================================================================*/

 .controller('themeCtrl', function($scope,SongBDFactory,$ionicLoading,$timeout) {
 	$scope.groups = [];
 	window.ga.trackView('themeScreen');
 	
 	$scope.getSongsThemes = function(){
 		SongBDFactory.getSongsThemes()
 		.then (function  (results) {
 			$scope.songsThemes=results.rows;
 			accordionData($scope.songsThemes);
 		}, function  (error) {
 			console.log(error.message);
 		}
 		);
 	}

 	$scope.getSongsFromTheme = function(theme,id){
 		var songs={};
 		SongBDFactory.getSongsFromTheme(theme)
 		.then (function  (results) {
 			for (var i = 0; i < results.rows.length; i++) {
 				songs[i] =	results.rows.item(i);
 			}
 			$scope.groups[id].items = songs;
 		}, function  (error) {
 			console.log(error.message);
 		}
 		);
 	}

 	function accordionData (themes) {
 		for (var i=0; i<themes.length; i++) {
 			$scope.groups[i] = {
 				name: themes.item(i).theme,
 				items: []
 			};
 		}
 		$ionicLoading.hide();
 	}

 	$ionicLoading.show({
 		template: "loading..."
 	}); 

 	$scope.getSongsThemes();
 	
  /*
   * if given group is the selected group, deselect it
   * else, select the given group
   */
   $scope.toggleGroup = function(group,id) {
   	
   	
   	if ($scope.isGroupShown(group)) {
   		$scope.shownGroup = null;
   		$scope.groups[id].items={};
   	} else {
   		$scope.getSongsFromTheme(group.name,id);
   		$scope.shownGroup = group;
   	}
   	
   };

   $scope.isGroupShown = function(group) {
   	return $scope.shownGroup === group;
   };
})

/*==========================================================================
 ====================== App Favorite ====================================
 =========================================================================*/

 .controller('favorisCtrl', function($scope,SongBDFactory,$state) {
 	
 	window.ga.trackView('favoriteScreen');
 	 $scope.noFavorites = false;
 	$scope.shouldShowDelete = false;
 	$scope.listCanSwipe =true;
 	$scope.favorites={};
 	$scope.getFavoritesSongs = function  () {
 		SongBDFactory.getFavoritesSongs()
 		.then( function  (result) {
 			console.log('my favlen'+result.rows.length);
 			favoritesLength = result.rows.length;
 			for (i = 0; i < favoritesLength; i++){
 				$scope.favorites[i] = result.rows.item(i);
 				//alert($scope.favorites[i].number);
 			}
 			 if (result.rows.length==0)
                $scope.noFavorites = true;
 			
 			console.log('my fav'+$scope.favorites);
 		}, function  (error) {
 			console.log(error.message);
 		}
 		);
 	}
 	$scope.myGoBack = function() {
    $ionicHistory.goBack();
  };

 	$scope.removeFavorite = function  (favoriteNumber,id) {
 		console.log(id);
 		SongBDFactory.removeFavoriteSong(favoriteNumber)
 		.then( function  (result) {
 			console.log('removed with success');
 			
 			//$state.go("menu");
 			delete $scope.favorites[id];

 		}, function  (eroor) {
 			console.log(error.message);
 		}
 		);
 	}

 	$scope.getFavoritesSongs();
 })
/*==========================================================================
  ====================== App Lyrics ====================================
  =========================================================================*/

  .controller('lyricsCtrl', function($scope,$rootScope ,$stateParams, SongBDFactory,$cordovaMedia,$state,$interval) {
  	$scope.formData ={};
  	$rootScope.number ={};
  	window.ga.trackView('	lyricsScreen');
  	$scope.getSongFromNumber = function (number) {
  		SongBDFactory.getSongFromNumber(number)
  		.then (function  (results) {
  			$scope.song=results.rows.item(0);
  			console.log($scope.song);
  			$scope.formData.number='';
  			if ($scope.song.favorite == '1')
  				$scope.favorite=true;
  			else
  				$scope.favorite =false;


  		}, function  (error) {
  			console.log(error.message);
  		});
  	}

  	if ($stateParams.number){
  		$rootScope.number = $stateParams.number; 
  		$scope.getSongFromNumber($rootScope.number);
  		
  	}

  	$scope.processForm = function () {
  		if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'lyricsSearch');
        }
  		$rootScope.number = $scope.formData.number;
  		$scope.getSongFromNumber($rootScope.number );
  		
  	}
  	$scope.cheatQuickNav = function(){
  		if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'lyricsKbSearch');
        }
 		$scope.processForm();
 		
 	}
	
  	$scope.position=0;
  	
  	$scope.model={};

	//Set audio position on page
	setAudioPosition('0','0');
	var rangePos=0;

	$scope.playAudio= function () {
		if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'play');
        }
		var src = '/android_asset/MID/H'+$rootScope.number+'.mid';
		
		console.log(src);
		if ($rootScope.myMedia === null) {
			
			$rootScope.myMedia= new Media( src, onSuccess, onError);
			setAudioPosition('0','0');
			$rootScope.stops = false;
			$rootScope.pause = false;
			$rootScope.myMedia.play();
		}
		else if ($rootScope.pause){

			$rootScope.pause=false;
			$rootScope.myMedia.play();

		}	
		if ($rootScope.mediaTimer === null) {
			$rootScope.mediaTimer = $interval(function() {
				$rootScope.myMedia.getCurrentPosition(
	                    // success callback
	                    function(position) {
	                    	if (position > -1) {
	                    		rangePos=(position*100)/$rootScope.dur;
	                    		if ($rootScope.dur>0){
	                    			setAudioPosition(Math.round(position),Math.round(rangePos));
	                    		}
	                            // get$rootScope.duration() can take a few seconds so keep trying
	                            // this could be done a better way, no callback for it
	                            if ($rootScope.dur <= 0) {
	                            	$rootScope.dur = $rootScope.myMedia.getDuration();
	                            	if ($rootScope.dur > 0) {
	                            		$rootScope.dur = Math.round($rootScope.dur);

	                            	}
	                            }
	                        }
	                    },
	                    // error callback
	                    function(e) {
	                    	alert("Error getting pos=" + e);
	                    	setAudioPosition("Error: " + e);
	                    }
	                    );
			}, 1000);
		}

	}

	function setAudioPosition(position, rangePos) {
	  // console.log(rangePos);
	 
	  $scope.position = position;
	  $scope.model.currentPos = rangePos;
	}       

	function onError(error) {
		console.log('code: '    + error.code    + '\n' +
			'message: ' + error.message + '\n');
		$interval.cancel($rootScope.mediaTimer);
		$rootScope.mediaTimer = null;

		$rootScope.myMedia = null;

		setAudioPosition('0','0');
	}

	function onSuccess() {
		$interval.cancel($rootScope.mediaTimer);
		
		$rootScope.mediaTimer = null;

		$rootScope.myMedia = null;

		$rootScope.dur = -1;
		setAudioPosition('0','0');
		if($rootScope.stops==false){
			
			$scope.playAudio();
		}
	}
	$scope.stopAudio = function () {

		if ($rootScope.myMedia) {
			
	        // A successful .stop() will call .release()
	        $rootScope.myMedia.stop();
	        $rootScope.stops=true;
	        $rootScope.pause=false;
	        $rootScope.myMedia.release();
	        $rootScope.myMedia = null;
	    }
	    if ($rootScope.mediaTimer) {
	    	$interval.cancel($rootScope.mediaTimer);
	    	$rootScope.mediaTimer = null;
	    }
	    setAudioPosition('0','0');
	    $rootScope.dur = 0;
	    if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'stop');
        }
	}

	$scope.pauseAudio= function () {

		if (!$rootScope.pause){
			$rootScope.myMedia.pause();
			$rootScope.pause=true;
			$rootScope.stops=false;
			if ($rootScope.mediaTimer) {
				$interval.cancel($rootScope.mediaTimer);
				$rootScope.mediaTimer = null;

			}
		}
		if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'pause');
        }
	}

	$scope.seekAudio = function(pos)
	{
		
		pos= ($rootScope.dur * pos )/100;
		if ($rootScope.myMedia) {
			$rootScope.myMedia.seekTo(pos*1000);
		}
		 if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'seekAudio');
        }
	}




	$scope.onSwipeLeft= function(){
		console.log('swipe');
		$state.go('score', {number:$rootScope.number});
	}

	$scope.viewScore = function(){
		$state.go('score', {number:$rootScope.number});
	}

	$scope.nextNumber = function () {

		$rootScope.number++;
		if ($rootScope.number<655)
			$scope.getSongFromNumber($rootScope.number);
		 if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'nextNumber');
        }
	}

	$scope.previousNumber = function () {
		$rootScope.number--;
		if ($rootScope.number>0)
			$scope.getSongFromNumber($rootScope.number);
		 if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'previousNumber');
        }
	}


	$scope.viewScore = function () {
		$scope.onSwipeLeft();
	}

	$scope.toggleFavoris = function () {
		 if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'favorite');
        }
		if ($scope.favorite == false){
			$scope.addFavorite($rootScope.number);
			$scope.favorite = true
			console.log ($scope.favorite);
		  			//$scope.favoriteImage = "addFavoriteImage"
		  		}
		  		else{
		  			$scope.removeFavorite($rootScope.number);
		  			$scope.favorite = false
		  		}  		

		  	}


		  	$scope.addFavorite = function  (favoriteNumber) {
		  		SongBDFactory.addFavoriteSong(favoriteNumber)
		  		.then( function  (result) {
		  			console.log('added with success');
		  		}, function  (error) {
		  			console.log(error.message);
		  		}
		  		);
		  	}

		  	$scope.removeFavorite = function  (favoriteNumber) {
		  		SongBDFactory.removeFavoriteSong(favoriteNumber)
		  		.then( function  (result) {
		  			console.log('removed with success');
		  		}, function  (eroor) {
		  			console.log(error.message);
		  		}
		  		);
		  	}	
		  })

/*==========================================================================
 ====================== App Score ====================================
 =========================================================================*/

 .controller('scoreCtrl', function($scope,$rootScope,$ionicPopup,$stateParams,$cordovaFileTransfer,$cordovaFile,$timeout) {
 	var fixNumber = function (i){
 		var number = '';
 		if (i> 0 && i <=9)
 			return number = '00'+i;
 		else if(i>9 && i<=99)
 			return number = '0'+i;
 		else return i;
 	}

 	$scope.showScore=false;
 	$scope.downloadAll=false;
 	$scope.freespace=0;
 	$rootScope.ScoreNumber=fixNumber($stateParams.number)
 	$scope.scoreDir = cordova.file.dataDirectory+ "scores/";
 	$scope.scoreFile ="H"+$rootScope.ScoreNumber+".jpg" 

 	$cordovaFile.checkDir(cordova.file.dataDirectory, "scores")
 		.then(function(result) {
 					console.log(result);
 					$cordovaFile.checkFile(cordova.file.dataDirectory, "scores/H"+$rootScope.ScoreNumber+".jpg")
 						.then(function(result) {
 						console.log(result);
 						$scope.scorePath = cordova.file.dataDirectory+ "scores/H"+$rootScope.ScoreNumber+".jpg";
 						$scope.showScore=true;
 					}, 
 					function(err) { 
 						console.log(err);
 						$scope.showScore=false;
 						gotoDownload();
					});
 				}, 
 				function(err) { 
 					console.log(err);
 					$cordovaFile.createDir(cordova.file.dataDirectory, "scores")
 						.then(function(result) {
 						console.log(result);
 						$scope.showScore=false;
 						gotoDownload();
 					}, 
 					function(err) { 
 						console.log(err);
 						alert(err);
 					
 					});
 				});
 

 
 	
 	var gotoDownload = function(){
 		$cordovaFile.getFreeDiskSpace()
 		.then(function(result) {
 						$scope.freespace=result;
 						console.log($scope.freespace);
 					}, 
 					function(err) { 
 						console.log(err);
 					
 					});
 		
 	
 		$scope.progressval = 0;
 		$scope.stopinterval = null;
 		
 		$scope.completed=0;
 		$scope.tmp=0;

 		$scope.downloadSongs= function(){
 			var numberFrom=fixNumber('197');
 			var numberTo =fixNumber('200');
 			prepareDownload(numberFrom,numberTo);
 		}
 		$scope.downloadSong= function(){
 			var numberFrom=$rootScope.ScoreNumber;
 			var numberTo =$rootScope.ScoreNumber;
 			//prepareDownload(numberFrom,numberTo);
 			download($rootScope.ScoreNumber);
 		}

 		$scope.deleteSong= function(){
 			$cordovaFile.removeFile(cordova.file.dataDirectory, "scores/H"+$rootScope.ScoreNumber+".jpg")
 						.then(function(result) {
 						console.log(result);
 						$scope.showScore=false;
 					}, 
 					function(err) { 
 						console.log(err);
 						$scope.showScore=true;
 						gotoDownload();
					});
 		}
 			


 		/*var specialNumbers = ['198'];
 		$scope.total=0
 		var prepareDownload=function (numberFrom, numberTo) {
 			if (numberFrom==numberTo){
 				$scope.total=1;
 				for (var j = 0; j < specialNumbers.length; j++) {
 					if (numberFrom == specialNumbers[j]){
 						console.log(specialNumbers[j]);
 						$scope.total =2;
 						download(numberFrom+'s');
 						break;
 					}	
 				}
 				download(numberFrom);
 			}
 			else{
 				$scope.total=4;
 				$scope.downloadAll=true;
 				for (var i = numberFrom; i <=numberTo; i++) {
 					download(i);
 					for (var j = 0; j < specialNumbers.length; j++) {
 						if (i == specialNumbers[j]){
 							download(i+'s');
 							specialNumbers.splice(j,1);
 							break;
 						}	
 					}
 				}
 			}
 		}
*/
 		var download=function(number){
 				var url = "";
 				var filename = "";
 				var targetPath = '';
 				var trustHosts = true;
 				var options = {};	
 				url = "http://htbonpri.com/hymns654/H"+number+".jpg";
 				filename = url.split("/").pop();
 				targetPath = cordova.file.dataDirectory+'scores/' + filename;
 				
 				$cordovaFileTransfer.download(url, targetPath, options, trustHosts)
 				.then(function(result) {
 					console.log('download successful');
 					$cordovaFile.checkFile(cordova.file.dataDirectory, "scores/H"+$rootScope.ScoreNumber+".jpg")
 						.then(function(result) {
 						console.log(result);
 						$scope.scorePath = cordova.file.dataDirectory+ "scores/H"+$rootScope.ScoreNumber+".jpg";
 						$scope.showScore=true;
 					}, 
 					function(err) { 
 						var alertPopup = $ionicPopup.alert({
 							title: 'Erreur de téléchargement!',
 						template: 'Vérifier la connexion internet!'
 			});
					});
 				}, 
 				function(err) {
 					console.log(err);
 					var alertPopup = $ionicPopup.alert({
 				title: 'Erreur de téléchargement!',
 				template: 'Vérifier la connexion internet!'
 			});
 				}, 
 				function (progress) {
 					$timeout(function () {
 						$scope.progressval = Math.round((progress.loaded / progress.total) * 100);
 						console.log('progresse val:'+$scope.progressval);
 						if ($scope.progressval==100){
 							$scope.tmp++
 							$scope.completed=($scope.tmp/$scope.total)*100;
						//	console.log('completed: '+$scope.completed);
					}
				});
 				});
 		}
 		}

 	})
/*==========================================================================
 ====================== App Controller ====================================
 =========================================================================*/

 .controller('menuCtrl', function($scope,$location,$ionicPopup,$ionicModal,$state,SongBDFactory,$interval, $ionicPlatform, $cordovaMedia, $cordovaFile ) {
 	$scope.getSongThemes = function  () {
 		SongBDFactory.getSongThemes()
 		.then (function  (results) {
 			console.log(results.rows.item(3).theme);
 			console.log(results);
 			
 		}, function  (error) {
 			console.log(error.message);
 		}
 		);
 	};


 	$scope.formData={};

 	$scope.cheatQuickNav = function(){
 		$scope.processForm();
 		if (typeof analytics !== 'undefined'){
          window.ga.trackEvent('bottonClick', 'searchKbMenu');
        }
 	}

 	$scope.processForm = function (){
 		
 		if ($scope.formData.number < 1 || $scope.formData.number > 654){
 			var alertPopup = $ionicPopup.alert({
 				title: 'Mauvais numéro!',
 				template: 'le numéro doit etre compris entre 1 et 654!'
 			});
 		}
 		else
 			$state.go('lyrics', {number: $scope.formData.number})
 	}
function _waitForAnalytics(){
    if (typeof analytics !== 'undefined'){
    
      window.ga.startTrackerWithId('UA-45830113-1');
      window.ga.setUserId('USER_ID');
      window.ga.trackView('menuScreen');
    }
    else{
      setTimeout(function(){
        _waitForAnalytics();
      },250);
    }
  };
  _waitForAnalytics();

 	
 	

      

   $scope.showAbout = function () {
   		window.ga.trackView('aboutScreen');
        $scope.showModalAbout('templates/aboutModal.html');       
    }

    
    $scope.showModalAbout = function(templateUrl) {
        $ionicModal.fromTemplateUrl(templateUrl, {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modalAbout = modal;
            $scope.modalAbout.show();
        });
   }

    // Close the modal
    $scope.closeModalAbout = function() {
        $scope.modalAbout.hide();
        $scope.modalAbout.remove()
         
    }
 	
 })
