angular.module('app.routes', [])

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js

//ion-ios-arrow-back
$ionicConfigProvider.backButton.icon('ion-chevron-left');
$ionicConfigProvider.navBar.alignTitle('center');
$ionicConfigProvider.backButton.previousTitleText(true);
  $stateProvider
    
  

  
  .state('theme', {
    url: '/theme',
    templateUrl: 'templates/theme.html',
    controller: 'themeCtrl'
   })

  .state('favoris', {
    url: '/favoris',
    templateUrl: 'templates/favoris.html',
    controller: 'favorisCtrl'
  })

  .state('menu', {
    url: '/menu',
    templateUrl: 'templates/menu.html',
    controller:'menuCtrl'
  })
 
  .state('score', {
    url: '/score/:number',
    templateUrl: 'templates/score.html',
    controller:'scoreCtrl'
  })
  .state('alpha', {
    url: '/alpha',
    templateUrl: 'templates/alpha.html',
    controller:'alphaCtrl'
  })
   .state('search', {
    url: '/search',
    templateUrl: 'templates/search.html',
    controller:'searchCtrl'
  })

  .state('lyrics', {
    url: '/lyrics/:number',
    templateUrl: 'templates/lyrics.html',
    controller: 'lyricsCtrl'
  })

  
$urlRouterProvider.otherwise('/menu')

  

});